GNU bug report logs - #64101
29.0.91; Eglot inlay hints rendered out of order

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Krzysztof Klimonda <kklimonda@HIDDEN>; dated Fri, 16 Jun 2023 05:57:04 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 17 Jun 2023 20:54:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 17 16:54:45 2023
Received: from localhost ([127.0.0.1]:52720 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qAcwV-0000ER-9O
	for submit <at> debbugs.gnu.org; Sat, 17 Jun 2023 16:54:45 -0400
Received: from lists.gnu.org ([209.51.188.17]:42054)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <milanj@HIDDEN>) id 1qAcwQ-0000E9-PT
 for submit <at> debbugs.gnu.org; Sat, 17 Jun 2023 16:54:42 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10])
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <milanj@HIDDEN>) id 1qAcwQ-0007Mx-Gt
 for bug-gnu-emacs@HIDDEN; Sat, 17 Jun 2023 16:54:38 -0400
Received: from mail-ed1-x531.google.com ([2a00:1450:4864:20::531])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <milanj@HIDDEN>) id 1qAcwO-0006wx-Ur
 for bug-gnu-emacs@HIDDEN; Sat, 17 Jun 2023 16:54:38 -0400
Received: by mail-ed1-x531.google.com with SMTP id
 4fb4d7f45d1cf-514ab6cb529so6209960a12.1
 for <bug-gnu-emacs@HIDDEN>; Sat, 17 Jun 2023 13:54:36 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=gmail.com; s=20221208; t=1687035275; x=1689627275;
 h=to:date:message-id:subject:mime-version:content-transfer-encoding
 :from:from:to:cc:subject:date:message-id:reply-to;
 bh=z31Zxi/2dOBe+Cng3gwkhtwnqF7LsDhRBNkIqYXd1E8=;
 b=X3l3tgEfkpWNzuNFCuzfeh9Uxkysrbtrtpsj2BhF59jARhePbNC1+7gbjh4xghAkvB
 5H9T4wRndXD33qzC/7e3dRyPaOeDYzNlOrzFz/DgIg/2L8vEccex85TtOxZOZ3iB/I1e
 QKKXaL8fokSdVKBDK059OgPzvs6ujVG/PkfcUGzfcUbs9fOpHtKEXwI5z8bZM5T4NKse
 /9+Um0FTYNoGSRZiAzJEAATMgWcD0IYY6qEUtm5VFEnUvCjn+Nl5JeD2mHeU4Vim7EBD
 0UuODKqJQ8gqutafSyc2nAkHvoVmsJgOadfm4AIMHD+YHDzfVJJsntO4ihJoi5BUuciu
 P05w==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20221208; t=1687035275; x=1689627275;
 h=to:date:message-id:subject:mime-version:content-transfer-encoding
 :from:x-gm-message-state:from:to:cc:subject:date:message-id:reply-to;
 bh=z31Zxi/2dOBe+Cng3gwkhtwnqF7LsDhRBNkIqYXd1E8=;
 b=ks21LbHqt/JDMZCDWonHnQ2FNKWJfXasRnQ8L5fYgxBVjRDuk8dbFefBViM7vQ730q
 VlZwtqVue46EUMir2rayXr02dsh5bifqAPNPXtcIsUjcASPxgzyAqIh8uBIF8Smj74mI
 1iXMYipNrnqhLhLz35ZvvNA9Wjd4Pt773WReIY3JRosBBwaHkkByl4d3X/jt8qcq0rlL
 n2IS50pT7WpetY/tRtdnAG18sQbcsrhFjmPbf106+Hn79AtGLMkV0P/F1cdai2V2QcBF
 hlnAwf416q9588Ao5oCer/2CMWssVTG0krQKRU5V+WmS3d36NfkK5+08ACkzCG5n/DUN
 RbxA==
X-Gm-Message-State: AC+VfDwaSNruIna792poRXSbtHjmX0tBPIpHWnpKn6N3B6OTv7ixF0MO
 urhSkrkvwnksQI6gRhigWyyie8OJHRY=
X-Google-Smtp-Source: ACHHUZ5kAE76aTpommXs5EIveM5fUptzyDyhlvOloNUZOhpK34MEl9SIHXHMZP7+GZmcvNUjfaxwkg==
X-Received: by 2002:a17:907:72ce:b0:96f:a412:8b03 with SMTP id
 du14-20020a17090772ce00b0096fa4128b03mr5343020ejc.5.1687035274620; 
 Sat, 17 Jun 2023 13:54:34 -0700 (PDT)
Received: from smtpclient.apple ([87.116.166.45])
 by smtp.gmail.com with ESMTPSA id
 bl5-20020a170906c24500b00982b8cd7a44sm3534551ejb.139.2023.06.17.13.54.33
 for <bug-gnu-emacs@HIDDEN>
 (version=TLS1_2 cipher=ECDHE-ECDSA-AES128-GCM-SHA256 bits=128/128);
 Sat, 17 Jun 2023 13:54:33 -0700 (PDT)
From: Milan Jovanovic <milanj@HIDDEN>
Content-Type: text/plain;
	charset=utf-8
Content-Transfer-Encoding: quoted-printable
Mime-Version: 1.0 (Mac OS X Mail 16.0 \(3696.120.41.1.1\))
Subject: bug#64101: 29.0.91; Eglot inlay hints rendered out of order
Message-Id: <4A010D80-5F52-4FEF-A8E8-0250A7F3DA6F@HIDDEN>
Date: Sat, 17 Jun 2023 22:54:32 +0200
To: bug-gnu-emacs@HIDDEN
X-Mailer: Apple Mail (2.3696.120.41.1.1)
Received-SPF: pass client-ip=2a00:1450:4864:20::531;
 envelope-from=milanj@HIDDEN; helo=mail-ed1-x531.google.com
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FREEMAIL_FROM=0.001,
 RCVD_IN_DNSWL_NONE=-0.0001, SPF_HELO_NONE=0.001, SPF_PASS=-0.001,
 T_SCC_BODY_TEXT_LINE=-0.01 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

Hi,
This fixes more complicated types that I had issue with but I=E2=80=99ve =
noticed that it now breaks this example:
let mut x =3D vec![1,2,3];
x.insert(1, 1)=20
with type hints inserted =3D> x.insert(: index0, : element1)

> But maybe Milan/Krzystof can try this patch:
>
> diff =E2=80=94git a/lisp/progmodes/eglot.el b/lisp/progmodes/eglot.el
> index a65795f1dfc..0c000f72ec7 100644
> --- a/lisp/progmodes/eglot.el
> +++ b/lisp/progmodes/eglot.el
> @@ -3755,8 +3755,9 @@ eglot--update-hints-1
>                      (if peg-after-p
>                          (make-overlay (point) (1+ (point)) nil t)
>                        (make-overlay (1- (point)) (point) nil nil =
nil)))
> -                   (do-it (label lpad rpad firstp)
> -                     (let* ((tweak-cursor-p (and firstp peg-after-p))
> +                   (do-it (label lpad rpad i)
> +                     (let* ((firstp (zerop i))
> +                            (tweak-cursor-p (and firstp peg-after-p))
>                             (ov (make-ov))
>                             (text (concat lpad label rpad)))
>                        (when tweak-cursor-p (put-text-property 0 1 =
'cursor 1=20
> text))
> @@ -3767,17 +3768,18 @@ eglot--update-hints-1
>                                              (1 'eglot-type-hint-face)
>                                              (2 =
'eglot-parameter-hint-face)
>                                              (_ =
'eglot-inlay-hint-face))))
> +                       (overlay-put ov 'priority i)
>                        (overlay-put ov 'eglot--inlay-hint t)
>                        (overlay-put ov 'evaporate t)
>                        (overlay-put ov 'eglot--overlay t))))
> -                (if (stringp label) (do-it label left-pad right-pad =
t)
> +                (if (stringp label) (do-it label left-pad right-pad =
0)
>                   (cl-loop
>                    for i from 0 for ldetail across label
>                    do (eglot--dbind ((InlayHintLabelPart) value) =
ldetail
>                         (do-it value
>                                (and (zerop i) left-pad)
>                                (and (=3D i (1- (length label))) =
right-pad)
> -                               (zerop i))))))))))
> +                               i)))))))))
>     (jsonrpc-async-request
>      (eglot--current-server-or-lose)
>      :textDocument/inlayHint







Information forwarded to bug-gnu-emacs@HIDDEN:
bug#64101; Package emacs. Full text available.

Message received at 64101 <at> debbugs.gnu.org:


Received: (at 64101) by debbugs.gnu.org; 17 Jun 2023 19:02:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 17 15:02:37 2023
Received: from localhost ([127.0.0.1]:52647 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qAbC0-0005fy-QV
	for submit <at> debbugs.gnu.org; Sat, 17 Jun 2023 15:02:37 -0400
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:29959)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1qAbBz-0005fl-9l
 for 64101 <at> debbugs.gnu.org; Sat, 17 Jun 2023 15:02:35 -0400
Received: from pmg2.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg2.iro.umontreal.ca (Proxmox) with ESMTP id 136A080686;
 Sat, 17 Jun 2023 15:02:30 -0400 (EDT)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg2.iro.umontreal.ca (Proxmox) with ESMTP id EC615805BF;
 Sat, 17 Jun 2023 15:02:28 -0400 (EDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1687028549;
 bh=EwJCbvxK1wFeDXm5vQ9N7hZvpZ2l81n8TtnirTYtu+E=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date:From;
 b=F2LDas71U+DY6V/Xh1/C0iZOGc1Dd2/0fBKVsdr00vzN0F00CS1Xgu33x2ES1vIpH
 PPlDhBHK4fHquKLoFCIHyfABD2bm+J5zKpp1qb53Yao61AMQjpQrz9CnFx4q58W0i8
 PgX229vy2kHxa7EjQwtN/JyeEX1SfjDNmP7EF/b9Py1FJiJGNE2P0wcJlblANn3UfU
 P7+duRt0Esp5tzZ4272aX48TkuMYxySAjozUW+Wo/tBo2F/0NG87hp89A/2E8Ub08C
 +0uZHMgh5k7BcSui2wES5gydmZWT+X9r91D8F1yev1njPDoPfEtyqGRbtPpcT6UPaO
 kaFVwFdmuy/4Q==
Received: from pastel (unknown [45.72.207.87])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id C1191120A09;
 Sat, 17 Jun 2023 15:02:28 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: =?windows-1252?B?Sm/jbyBU4XZvcmE=?= <joaotavora@HIDDEN>
Subject: Re: bug#64101: 29.0.91; Eglot inlay hints rendered out of order
In-Reply-To: <877cs28m23.fsf@HIDDEN> (=?windows-1252?Q?=22Jo=E3o_T=E1vo?=
 =?windows-1252?Q?ra=22's?= message of "Sat, 17
 Jun 2023 10:39:32 +0100")
Message-ID: <jwvsfapora8.fsf-monnier+emacs@HIDDEN>
References: <AF24CBF4-1342-4D92-B7F9-8EE717BD8250@HIDDEN>
 <83r0qar07l.fsf@HIDDEN> <877cs28m23.fsf@HIDDEN>
Date: Sat, 17 Jun 2023 15:02:27 -0400
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL 0.085 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
 DKIM_VALID_EF -0.1 Message has a valid DKIM or DK signature from envelope-from
 domain T_SCC_BODY_TEXT_LINE    -0.01 -
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 64101
Cc: Eli Zaretskii <eliz@HIDDEN>,
 Krzysztof Klimonda <kklimonda@HIDDEN>, 64101 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

>> Should the overlays created for the
>> inlay hints be forced to be sorted in some particular order?
> Maybe, and there is definitely an order they should be sorted.

If they start and end at the exact same place, then the ordering by
default is arbitrary (IIRC it's sorted by memory address, simply
because we needed some cheap way to make the ordering total).

If you need a particular ordering between such overlays, then you
definitely need to use the `priority` property.

> --- a/lisp/progmodes/eglot.el
> +++ b/lisp/progmodes/eglot.el
> @@ -3755,8 +3755,9 @@ eglot--update-hints-1
>                       (if peg-after-p
>                           (make-overlay (point) (1+ (point)) nil t)
>                         (make-overlay (1- (point)) (point) nil nil nil)))
> -                   (do-it (label lpad rpad firstp)
> -                     (let* ((tweak-cursor-p (and firstp peg-after-p))
> +                   (do-it (label lpad rpad i)
> +                     (let* ((firstp (zerop i))
> +                            (tweak-cursor-p (and firstp peg-after-p))
>                              (ov (make-ov))
>                              (text (concat lpad label rpad)))
>                         (when tweak-cursor-p (put-text-property 0 1 'cursor 1 text))
> @@ -3767,17 +3768,18 @@ eglot--update-hints-1
>                                               (1 'eglot-type-hint-face)
>                                               (2 'eglot-parameter-hint-face)
>                                               (_ 'eglot-inlay-hint-face))))
> +                       (overlay-put ov 'priority i)
>                         (overlay-put ov 'eglot--inlay-hint t)
>                         (overlay-put ov 'evaporate t)
>                         (overlay-put ov 'eglot--overlay t))))

The `priority` property is a source of problem in itself so I'd
recommend to use its weaker version where the value is a cons cell
`(nil . SECONDARY)`.  This way the SECONDARY priority will only be used
as a last recourse (before using pointer addresses).

The doc discourages this use because when I introduced it (for use by
the Lisp reimplementation of the region highlighting, some time around
Emacs-24) I wasn't too sure how it would play out.  But I suspect we
should change the doc to let people use it without a bad conscience (or
maybe even encourage its use).


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#64101; Package emacs. Full text available.

Message received at 64101 <at> debbugs.gnu.org:


Received: (at 64101) by debbugs.gnu.org; 17 Jun 2023 16:43:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 17 12:43:45 2023
Received: from localhost ([127.0.0.1]:52543 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qAZ1d-0001ry-Hr
	for submit <at> debbugs.gnu.org; Sat, 17 Jun 2023 12:43:45 -0400
Received: from mail-oa1-f54.google.com ([209.85.160.54]:55395)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <joaotavora@HIDDEN>) id 1qAZ1b-0001rh-8s
 for 64101 <at> debbugs.gnu.org; Sat, 17 Jun 2023 12:43:44 -0400
Received: by mail-oa1-f54.google.com with SMTP id
 586e51a60fabf-19a427d7b57so1324585fac.2
 for <64101 <at> debbugs.gnu.org>; Sat, 17 Jun 2023 09:43:43 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=gmail.com; s=20221208; t=1687020217; x=1689612217;
 h=content-transfer-encoding:cc:to:subject:message-id:date:from
 :in-reply-to:references:mime-version:from:to:cc:subject:date
 :message-id:reply-to;
 bh=syEtt0XojFIi33ym/GEem+rlJcyttqAkIU83Y4pq7Sc=;
 b=ssupjhzt2igZzEm84T6LGvnw5cVQBDT2YxfFrhkZ526cqBoD2E+FgJjRjWWEVh/hyr
 zGRdorcmynk711iaKtX9piQmEO7z4ClxZIOu+lxGoq5sWQmRWIN3EqLFF4QKPQh2zleF
 juusAE9eBzlV27T4JGbN3QvgXoWollTrfo3VPWV8HtqvgQJ7t0XZrJhUK5cYK3L2aiJg
 UnLtke31do9evu3cg0/IX7ncm0c1PQ1XLBzQgGEDqkoXxr9u6lSZ12ehfIXqEznzAYeE
 djLnVuxS5AktYB5cJOZ0fiWgyH2zFhlWL8/euG39MZYgMfaxDNoXZ0aXHNg32CRu+nmN
 6lkw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20221208; t=1687020217; x=1689612217;
 h=content-transfer-encoding:cc:to:subject:message-id:date:from
 :in-reply-to:references:mime-version:x-gm-message-state:from:to:cc
 :subject:date:message-id:reply-to;
 bh=syEtt0XojFIi33ym/GEem+rlJcyttqAkIU83Y4pq7Sc=;
 b=IKT01ZeKo44C/dAlmAXFKF5MQyi+rFn3fLwW3H78xPkZBUq5e4ofBd8yx8NVa4++xb
 PvX472JJDEPDaWSvYfyVpFYAFNolXDURvhGAtLffLZ9J4B9NdU8Kh7LbeGleQw6Q/l2V
 /ob/f9Led07Pup4AmXkgVMBHLZ0nptPN20Nkv052R8hDaQM/xm/Ki7eG/e2uZegRChn4
 FS32HgAanNgl22RPSpfDyNn2tIfNSfVqQd1QzpqUVMpDvwlExbKb4k3ECxb45jyTEp3C
 NOwMYDrbGQRST9Ofula7vunFRns4Ix0Vyt+TvxevsOFwXIS+GC7/1skZilXj0YLkS82I
 6amQ==
X-Gm-Message-State: AC+VfDx/bZUbsE0N0HGHg3zphWLzM3KJW7Ly8sVGKzPOWMv5SjO35al6
 BFzzRBT/dczcfRagk4SiSbrEeUJ2LUL2Il8Pbw4=
X-Google-Smtp-Source: ACHHUZ4yPDhcgy6lfheJpIlcz+LHBkWxKkfU5cvcyfObjCIEKQvlXwa5ouH/TcgiMTSixX3Au/RwwgePB4uLxhqNmfA=
X-Received: by 2002:a05:6870:9712:b0:1a6:9a34:9acb with SMTP id
 n18-20020a056870971200b001a69a349acbmr1991671oaq.55.1687020217212; Sat, 17
 Jun 2023 09:43:37 -0700 (PDT)
MIME-Version: 1.0
References: <AF24CBF4-1342-4D92-B7F9-8EE717BD8250@HIDDEN>
 <83r0qar07l.fsf@HIDDEN> <877cs28m23.fsf@HIDDEN> <83edmaqskn.fsf@HIDDEN>
 <87352q8ent.fsf@HIDDEN> <835y7mqlcu.fsf@HIDDEN>
 <CALDnm503tZpri4gX6CR1G5B_Z5swp_Qd-UxbMJixVVkVO5WVnA@HIDDEN>
 <834jn6qisd.fsf@HIDDEN>
 <CALDnm52D18woq-5o4eo+3CWCESbnhr+uiW0hinZKeO-Tymev6w@HIDDEN>
 <83zg4yozov.fsf@HIDDEN>
In-Reply-To: <83zg4yozov.fsf@HIDDEN>
From: =?UTF-8?B?Sm/Do28gVMOhdm9yYQ==?= <joaotavora@HIDDEN>
Date: Sat, 17 Jun 2023 17:45:55 +0100
Message-ID: <CALDnm519bxTgCJyQVke8_-Ga-O7-3ph09S+06=R43wqvFsOYcg@HIDDEN>
Subject: Re: bug#64101: 29.0.91; Eglot inlay hints rendered out of order
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 64101
Cc: kklimonda@HIDDEN, monnier@HIDDEN,
 64101 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Sat, Jun 17, 2023 at 4:50=E2=80=AFPM Eli Zaretskii <eliz@HIDDEN> wrote:
>
> > From: Jo=C3=A3o T=C3=A1vora <joaotavora@HIDDEN>
> > Date: Sat, 17 Jun 2023 15:29:38 +0100
> > Cc: kklimonda@HIDDEN, 64101 <at> debbugs.gnu.org,
> >       monnier@HIDDEN
> >
> > > What order did your code expect in that case?
> >
> > The current order that I see on all my GNU Linux builds of Emacs (and a=
lso
> > my Windows builds, I'm fairly certain).  The after-string and before-st=
ring
> > of a a more recently created overlay is displayed after the least
> > recently created overlay, all other overlay things being equal,
> > of course.
>
> That was never the case. The creation order has no direct relevance
> to the display order of overlays that cover the same text and have the
> same priority.  What can affect the order is the address of each
> overlay in memory, but I don't think you can rely on memory-allocation
> routines to always allocate memory in the increasing order of
> addresses.

It's not true that it "was never the case".  Experimentally, it _is_
the case on all the Linux and (and Windows) builds I've ever used
to test Eglot on.  So instead of "never", I would say "most often,
though not necessarily always" and document this, else people like
me may assume that the behaviour they observe is guaranteed by the
system.

> So I don't think the code should rely on this assumption.

That's perfectly fair.  AFAICT, it doesn't anymore.

Jo=C3=A3o




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#64101; Package emacs. Full text available.

Message received at 64101 <at> debbugs.gnu.org:


Received: (at 64101) by debbugs.gnu.org; 17 Jun 2023 15:50:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 17 11:50:53 2023
Received: from localhost ([127.0.0.1]:52444 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qAYCT-0003q2-Bs
	for submit <at> debbugs.gnu.org; Sat, 17 Jun 2023 11:50:53 -0400
Received: from eggs.gnu.org ([209.51.188.92]:44052)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1qAYCO-0003pm-Fv
 for 64101 <at> debbugs.gnu.org; Sat, 17 Jun 2023 11:50:52 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1qAYCI-000593-Ew; Sat, 17 Jun 2023 11:50:42 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-version:References:Subject:In-Reply-To:To:From:
 Date; bh=O2+9Ux5+rGl22oHJs+rBI461/6qQMeEhy9W4rA/uvlY=; b=GGXfNPCY27zO2IwNugyw
 V5lBdhJglVD459CW4WBN1P98vb5iCQo9vnyB0IHKhx1e7FohKAV9noGZKT9coGE6Qox84542+Xj64
 786XTizhr0MK0qk5MnhUO+PxzkQMKqBIF4kB95tGArVvvcb9tnOhoiUJQpxQ7I91GdLSZJ5zMHnr6
 IAY4l9/4f4dsum1eU8PDoZKyNFr3OoFm4GRmkCGysw76qtjnN28rq5/t9UGoLmSbZoN8+7L3hv16j
 4KlnU3qXnT9ntY/92/biCFv1wcYlK6brtAJ2DWf6Qc5ioVLApBLTzMpQ6LDE0M6QnzJ4ohS/zkJPs
 L/5U39r4EEAuLQ==;
Received: from [87.69.77.57] (helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1qAYCH-0001G7-Qi; Sat, 17 Jun 2023 11:50:42 -0400
Date: Sat, 17 Jun 2023 18:50:40 +0300
Message-Id: <83zg4yozov.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: =?utf-8?B?Sm/Do28gVMOhdm9yYQ==?= <joaotavora@HIDDEN>,
 monnier@HIDDEN
In-Reply-To: <CALDnm52D18woq-5o4eo+3CWCESbnhr+uiW0hinZKeO-Tymev6w@HIDDEN>
 (message from =?utf-8?B?Sm/Do28gVMOhdm9yYQ==?= on Sat, 17 Jun 2023 15:29:38
 +0100)
Subject: Re: bug#64101: 29.0.91; Eglot inlay hints rendered out of order
References: <AF24CBF4-1342-4D92-B7F9-8EE717BD8250@HIDDEN>
 <83r0qar07l.fsf@HIDDEN> <877cs28m23.fsf@HIDDEN> <83edmaqskn.fsf@HIDDEN>
 <87352q8ent.fsf@HIDDEN> <835y7mqlcu.fsf@HIDDEN>
 <CALDnm503tZpri4gX6CR1G5B_Z5swp_Qd-UxbMJixVVkVO5WVnA@HIDDEN>
 <834jn6qisd.fsf@HIDDEN>
 <CALDnm52D18woq-5o4eo+3CWCESbnhr+uiW0hinZKeO-Tymev6w@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 64101
Cc: kklimonda@HIDDEN, 64101 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: João Távora <joaotavora@HIDDEN>
> Date: Sat, 17 Jun 2023 15:29:38 +0100
> Cc: kklimonda@HIDDEN, 64101 <at> debbugs.gnu.org, 
> 	monnier@HIDDEN
> 
> > What order did your code expect in that case?
> 
> The current order that I see on all my GNU Linux builds of Emacs (and also
> my Windows builds, I'm fairly certain).  The after-string and before-string
> of a a more recently created overlay is displayed after the least
> recently created overlay, all other overlay things being equal,
> of course.

That was never the case.  The creation order has no direct relevance
to the display order of overlays that cover the same text and have the
same priority.  What can affect the order is the address of each
overlay in memory, but I don't think you can rely on memory-allocation
routines to always allocate memory in the increasing order of
addresses.

So I don't think the code should rely on this assumption.

Stefan, am I missing something?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#64101; Package emacs. Full text available.

Message received at 64101 <at> debbugs.gnu.org:


Received: (at 64101) by debbugs.gnu.org; 17 Jun 2023 14:27:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 17 10:27:31 2023
Received: from localhost ([127.0.0.1]:52240 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qAWtm-0007Kr-Uf
	for submit <at> debbugs.gnu.org; Sat, 17 Jun 2023 10:27:31 -0400
Received: from mail-oo1-f52.google.com ([209.85.161.52]:45475)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <joaotavora@HIDDEN>) id 1qAWth-0007KU-Gs
 for 64101 <at> debbugs.gnu.org; Sat, 17 Jun 2023 10:27:29 -0400
Received: by mail-oo1-f52.google.com with SMTP id
 006d021491bc7-55e04a83465so1219138eaf.3
 for <64101 <at> debbugs.gnu.org>; Sat, 17 Jun 2023 07:27:25 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=gmail.com; s=20221208; t=1687012039; x=1689604039;
 h=content-transfer-encoding:cc:to:subject:message-id:date:from
 :in-reply-to:references:mime-version:from:to:cc:subject:date
 :message-id:reply-to;
 bh=I4mRPewMH7zRYMwOUY7sCCBLy/lIFAv+krFKX3W/uQ0=;
 b=XTzoQl4iQNAf5MrniKDDbqKtdVXa24KjB/aWuC5TuJGGofqbpp6P2oWYiGG8TcAVx6
 a6+XqbKaJHFYwluxrRPfx56NbwQiX7Vn5s4lHQ6/JEtIpBUl2c2vMRrFK6tpT30MbFwt
 /FuE7FMuv9ChOyRiAM9Ficu0+dHfGQb2mhPUlOBo/s0s1+1uNMz5oRjoKZrd1agDdoA2
 Q3XGb7ZOBio7XaWsTZSP8y0gnJeUC+q9zkBj9JQYp26w1e+/f5yr9XSHKNKqbBfDSrOv
 gGE7Fdgl2BaSRRcgnA2KEU+6Ov60hYPsZPkKk4z7YwGMob1UUKYUOnKPR95Ih2e2xYwo
 6VqQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20221208; t=1687012039; x=1689604039;
 h=content-transfer-encoding:cc:to:subject:message-id:date:from
 :in-reply-to:references:mime-version:x-gm-message-state:from:to:cc
 :subject:date:message-id:reply-to;
 bh=I4mRPewMH7zRYMwOUY7sCCBLy/lIFAv+krFKX3W/uQ0=;
 b=Yr7LYLNmMt4hHEL+lUUtDjQunCDTtvRLoI6rkuHV8cWY7x89A+SFA0LgRRgnocO/id
 L5+5w29yAxBeJuefh065ztqZoJagn3YEjzAUq//4sVHp38rqpr4RF6NXgjQgFuQBIqZV
 4+vWmkwhyprCfYhsCiqtGH4/LGmFcIh6cgOUZ8g7EGy10VTZfpRCm7CThYRHfEFlWO6/
 KjRSdGcVpznLzz985e+WOvjvxVX7Cpd7eFmT4jkItt6jOnI4mCfGN0/SVQmyOYCATHSh
 a1v3PddHnhpSptGP0RKV92pZeZSvKHWbDT91pP3G71x4PttilxGp6oI+jQgtD38gDwvF
 HTKQ==
X-Gm-Message-State: AC+VfDwqZ/fFheU+SLiO6gEauZVGaZTaEACpVjy2BB0lFNJx+4NQ4VKt
 Gvvqnjgbp5z+mt7gVXBbIwggZfCHqZ/ZTEw0cAI=
X-Google-Smtp-Source: ACHHUZ7LJ6DLdRNv+KEHJ8/GFjwM9Wm8vvvI7MD3Sli06Hq2BLSjN0LbFr+9LMdoMdv9A7BGFKTW66knRgPF7Du1zYc=
X-Received: by 2002:a4a:bd8f:0:b0:558:b5c7:4832 with SMTP id
 k15-20020a4abd8f000000b00558b5c74832mr2593811oop.3.1687012039685; Sat, 17 Jun
 2023 07:27:19 -0700 (PDT)
MIME-Version: 1.0
References: <AF24CBF4-1342-4D92-B7F9-8EE717BD8250@HIDDEN>
 <83r0qar07l.fsf@HIDDEN> <877cs28m23.fsf@HIDDEN> <83edmaqskn.fsf@HIDDEN>
 <87352q8ent.fsf@HIDDEN> <835y7mqlcu.fsf@HIDDEN>
 <CALDnm503tZpri4gX6CR1G5B_Z5swp_Qd-UxbMJixVVkVO5WVnA@HIDDEN>
 <834jn6qisd.fsf@HIDDEN>
In-Reply-To: <834jn6qisd.fsf@HIDDEN>
From: =?UTF-8?B?Sm/Do28gVMOhdm9yYQ==?= <joaotavora@HIDDEN>
Date: Sat, 17 Jun 2023 15:29:38 +0100
Message-ID: <CALDnm52D18woq-5o4eo+3CWCESbnhr+uiW0hinZKeO-Tymev6w@HIDDEN>
Subject: Re: bug#64101: 29.0.91; Eglot inlay hints rendered out of order
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 64101
Cc: kklimonda@HIDDEN, 64101 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Sat, Jun 17, 2023 at 3:12=E2=80=AFPM Eli Zaretskii <eliz@HIDDEN> wrote:

> > IMO, unexpected behaviour doesn't have to go against actual documented
> > behaviour to be considered a bug.  However if you know that this
> > indefinition exists and you want it to enshrine it (say, for some perfo=
rmance
> > reason) then I believe this should be documented.
>
> What order did your code expect in that case?

The current order that I see on all my GNU Linux builds of Emacs (and also
my Windows builds, I'm fairly certain).  The after-string and before-string
of a a more recently created overlay is displayed after the least
recently created overlay, all other overlay things being equal,
of course.

> > > > In any case, one defensive option is to push the patch I showed to =
Emacs
> > > > 29.  Subject, of course, to testing on at least some machine where =
the
> > > > problem does indeed happen.
> > >
> > > Yes, let's wait for the confirmation that it fixes the problem.
> >
> > I think it has already been tested successfully.
>
> Yes, so I think the fix should be installed.

Done.

Jo=C3=A3o




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#64101; Package emacs. Full text available.

Message received at 64101 <at> debbugs.gnu.org:


Received: (at 64101) by debbugs.gnu.org; 17 Jun 2023 14:13:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 17 10:13:02 2023
Received: from localhost ([127.0.0.1]:52230 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qAWfl-0004Tj-Si
	for submit <at> debbugs.gnu.org; Sat, 17 Jun 2023 10:13:02 -0400
Received: from eggs.gnu.org ([209.51.188.92]:45734)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1qAWfj-0004TF-OL
 for 64101 <at> debbugs.gnu.org; Sat, 17 Jun 2023 10:13:00 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1qAWfd-0003du-IF; Sat, 17 Jun 2023 10:12:53 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-version:References:Subject:In-Reply-To:To:From:
 Date; bh=ITLfoPx6VtkQNvdL2pekrbpWFh39fAGnsH5TumBqBjY=; b=jHa/EgLMBPA9r2a2UJCw
 sXm48+5wRDRfO+uLJ7RccwNBm9dA1cWJGnOMhD5rJlCFi79DF16+gL6PHygTxDf6ukOVKEV09P2+z
 e3vIhlTwPIObnbi7Z0u/GqQ9kIFz4wGpE0eY4khqOnFdB/v8pulJC9D7BBbQh1O4FbQ4tZbLbpbIF
 BwEdwq+y3HnNeOFzkA/6zj3+3XjGALISEIOaNTvSjd0/+O9f0JLnOIkA5rmv+Pj+1M4SJGUoZmYyF
 5F6Zssci7eWPz5vDqcp1MBj6aS7dwIuTEAQOBovrE8UGDO+0d4XE7tJS1QWgdfpvRDPSViP2oIfRb
 T2zvgv4Bo4kdhA==;
Received: from [87.69.77.57] (helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1qAWfa-0004Tn-R7; Sat, 17 Jun 2023 10:12:53 -0400
Date: Sat, 17 Jun 2023 17:12:50 +0300
Message-Id: <834jn6qisd.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: =?utf-8?B?Sm/Do28gVMOhdm9yYQ==?= <joaotavora@HIDDEN>
In-Reply-To: <CALDnm503tZpri4gX6CR1G5B_Z5swp_Qd-UxbMJixVVkVO5WVnA@HIDDEN>
 (message from =?utf-8?B?Sm/Do28gVMOhdm9yYQ==?= on Sat, 17 Jun 2023 14:26:48
 +0100)
Subject: Re: bug#64101: 29.0.91; Eglot inlay hints rendered out of order
References: <AF24CBF4-1342-4D92-B7F9-8EE717BD8250@HIDDEN>
 <83r0qar07l.fsf@HIDDEN> <877cs28m23.fsf@HIDDEN> <83edmaqskn.fsf@HIDDEN>
 <87352q8ent.fsf@HIDDEN> <835y7mqlcu.fsf@HIDDEN>
 <CALDnm503tZpri4gX6CR1G5B_Z5swp_Qd-UxbMJixVVkVO5WVnA@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 64101
Cc: kklimonda@HIDDEN, 64101 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: João Távora <joaotavora@HIDDEN>
> Date: Sat, 17 Jun 2023 14:26:48 +0100
> Cc: kklimonda@HIDDEN, 64101 <at> debbugs.gnu.org, 
> 	monnier@HIDDEN
> 
> > Does any documentation promise any particular order of overlays?
> 
> No, not that I know of, but it's just the behaviour I've always observed.
> This seemingly MacOS-specific undefinition is the first time I hear of this
> behaviour.
> 
> IMO, unexpected behaviour doesn't have to go against actual documented
> behaviour to be considered a bug.  However if you know that this
> indefinition exists and you want it to enshrine it (say, for some performance
> reason) then I believe this should be documented.

What order did your code expect in that case?

> > > In any case, one defensive option is to push the patch I showed to Emacs
> > > 29.  Subject, of course, to testing on at least some machine where the
> > > problem does indeed happen.
> >
> > Yes, let's wait for the confirmation that it fixes the problem.
> 
> I think it has already been tested successfully.

Yes, so I think the fix should be installed.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#64101; Package emacs. Full text available.

Message received at 64101 <at> debbugs.gnu.org:


Received: (at 64101) by debbugs.gnu.org; 17 Jun 2023 13:24:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 17 09:24:38 2023
Received: from localhost ([127.0.0.1]:51053 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qAVuw-0002q4-AN
	for submit <at> debbugs.gnu.org; Sat, 17 Jun 2023 09:24:38 -0400
Received: from mail-oo1-f44.google.com ([209.85.161.44]:47398)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <joaotavora@HIDDEN>) id 1qAVut-0002pb-Nn
 for 64101 <at> debbugs.gnu.org; Sat, 17 Jun 2023 09:24:36 -0400
Received: by mail-oo1-f44.google.com with SMTP id
 006d021491bc7-558a79941c6so1165181eaf.3
 for <64101 <at> debbugs.gnu.org>; Sat, 17 Jun 2023 06:24:35 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=gmail.com; s=20221208; t=1687008270; x=1689600270;
 h=content-transfer-encoding:cc:to:subject:message-id:date:from
 :in-reply-to:references:mime-version:from:to:cc:subject:date
 :message-id:reply-to;
 bh=7Te8f2houp4+bKLRGE3QnegWXq6zYpDDqv44A0Gyc/I=;
 b=msj4omhRXmWJihwrGPogYxKAJKT8D/RedzfsHAtjSpmhT2FknDFgnjXbFRUOQ8KUU3
 J6c/uaGPYHNzUqNvlk7fk4JZ8U2SYdNcjSPXf7cVCTfGxZ8XYn8IDqv9eaRV4w5qOKtl
 JvMKHvmPkfr04Otfydww8jWa+ivyE0I1RtbOgTfa+/kgH+GiOhfasMhrzdjSD7gSGjZ5
 n1h6g0v/ZKwvxWgJ8wl7DKVh/Rv0Anly/x02D0Htl33HhkCor4hL0CLCwGF8K7tHb3dR
 ZlljiF1emNjg16qoWymINwFLGA52sZY3pMMityP0OAjI8P4JkFFlCgnM+rSCW9gCgy/J
 VJUQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20221208; t=1687008270; x=1689600270;
 h=content-transfer-encoding:cc:to:subject:message-id:date:from
 :in-reply-to:references:mime-version:x-gm-message-state:from:to:cc
 :subject:date:message-id:reply-to;
 bh=7Te8f2houp4+bKLRGE3QnegWXq6zYpDDqv44A0Gyc/I=;
 b=gWsJxtm4gPKNSjpnhzDjSeOD2JIuQltDa0AyxwxiMFEdJF0HLh9kycNwemRrDywVXj
 dGzl374HvMH6sIAzp7q0Exf8IKEEOhlJxQ/oa62R0PQ5+W9SSkWwJIL7QLlZDqIsJbgy
 VpuoFG288f2zFkkdzONB3BhvYqxONwE2HnDK+wrSiZq4SdBqAYPibzlAJGyzi0fN8snP
 Ig8TU7t8fFsUVIW4yR+82j0hWOYr1S3mBryB9N34XgVCPN9kg9/0EXtxbDx3i2NohG3N
 VZsac8OkgDKbchZjw+CG8AbOwqrxrKhdk1Fw0MkgaUpCVwAqlVf7zIWHZ4vKVwFiL4/8
 L39g==
X-Gm-Message-State: AC+VfDwc29aOwd7HrOV1g1a7dU4WmYRwK3AaFFrLZ/L6/1PbcbcNdxmK
 HK3lBLvtPzgntp+m2vg4MtFNnTXye1pAFzxIKrk=
X-Google-Smtp-Source: ACHHUZ658UEvrCMuv0euqlhmolqEsq4+GZfg0p1yP0RhaLrVB6lCbvM9/de3CdgJAIf3dENKDZ46tT3tMEwOYG6SLnE=
X-Received: by 2002:a4a:b502:0:b0:555:7682:7644 with SMTP id
 r2-20020a4ab502000000b0055576827644mr2025668ooo.2.1687008269637; Sat, 17 Jun
 2023 06:24:29 -0700 (PDT)
MIME-Version: 1.0
References: <AF24CBF4-1342-4D92-B7F9-8EE717BD8250@HIDDEN>
 <83r0qar07l.fsf@HIDDEN> <877cs28m23.fsf@HIDDEN> <83edmaqskn.fsf@HIDDEN>
 <87352q8ent.fsf@HIDDEN> <835y7mqlcu.fsf@HIDDEN>
In-Reply-To: <835y7mqlcu.fsf@HIDDEN>
From: =?UTF-8?B?Sm/Do28gVMOhdm9yYQ==?= <joaotavora@HIDDEN>
Date: Sat, 17 Jun 2023 14:26:48 +0100
Message-ID: <CALDnm503tZpri4gX6CR1G5B_Z5swp_Qd-UxbMJixVVkVO5WVnA@HIDDEN>
Subject: Re: bug#64101: 29.0.91; Eglot inlay hints rendered out of order
To: Eli Zaretskii <eliz@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 64101
Cc: kklimonda@HIDDEN, 64101 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Sat, Jun 17, 2023 at 2:17=E2=80=AFPM Eli Zaretskii <eliz@HIDDEN> wrote:

> > I would find this "undefined order" strange, and perhaps a bug in
> > itself.  Maybe whoever rewrote the overlay code (Stefan?) could chime
> > in.
>
> It wasn't Stefan, he just merged the branch to master and fixed bugs.
>
> But why do you say this is a bug?

I didn't: I suggested it _might_ be and asked for an expert opinion
to weigh in.  It's quite different.

> Does any documentation promise any particular order of overlays?

No, not that I know of, but it's just the behaviour I've always observed.
This seemingly MacOS-specific undefinition is the first time I hear of this
behaviour.

IMO, unexpected behaviour doesn't have to go against actual documented
behaviour to be considered a bug.  However if you know that this
indefinition exists and you want it to enshrine it (say, for some performan=
ce
reason) then I believe this should be documented.

> > In any case, one defensive option is to push the patch I showed to Emac=
s
> > 29.  Subject, of course, to testing on at least some machine where the
> > problem does indeed happen.
>
> Yes, let's wait for the confirmation that it fixes the problem.

I think it has already been tested successfully.

Jo=C3=A3o




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#64101; Package emacs. Full text available.

Message received at 64101 <at> debbugs.gnu.org:


Received: (at 64101) by debbugs.gnu.org; 17 Jun 2023 13:17:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 17 09:17:33 2023
Received: from localhost ([127.0.0.1]:51032 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qAVo4-0002dc-UX
	for submit <at> debbugs.gnu.org; Sat, 17 Jun 2023 09:17:33 -0400
Received: from eggs.gnu.org ([209.51.188.92]:59880)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1qAVnz-0002dN-HS
 for 64101 <at> debbugs.gnu.org; Sat, 17 Jun 2023 09:17:31 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1qAVnt-0001lL-UG; Sat, 17 Jun 2023 09:17:21 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-version:References:Subject:In-Reply-To:To:From:
 Date; bh=GeMuZi3YC4zcW4ZYThfwzxiA5odWLSSvoUKcTiTHu7U=; b=PVc0vr7o/LmNNUiGOGu1
 UOKTUfZvrVr02HlkU2a7qb+lu0nZzsLVonocgh0owE9HplZixqzCHCuHQ7uLVcuplYI/TtQ0ZKh0X
 D2upteBq9KyHwkHu3AOgGE/xTXCiaW/+eA1kJkIUIJarGr8fb/ebZ4FpbGCnd15Nrq/JBu2bIFMNw
 YBPuZPe4B4QQS8KQThk8SHiUcd+vnhCfAHkHbdH6P2BUYOPYljh4vZFdHsbKAq/26KEBQ7GZ2k9z9
 iKUuPTGv+eIncbP4f3Y2VokiPRYW5WE8ew1o8D3sLHQ539rMuDaRYQu27zknJTHgUdhd2+YVInW+a
 oKps0Xe1gTRhvg==;
Received: from [87.69.77.57] (helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1qAVnt-0003qy-J1; Sat, 17 Jun 2023 09:17:21 -0400
Date: Sat, 17 Jun 2023 16:17:21 +0300
Message-Id: <835y7mqlcu.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: =?utf-8?B?Sm/Do28gVMOhdm9yYQ==?= <joaotavora@HIDDEN>
In-Reply-To: <87352q8ent.fsf@HIDDEN> (message from =?utf-8?B?Sm/Do28g?=
 =?utf-8?B?VMOhdm9yYQ==?= on Sat, 17 Jun 2023 13:19:18 +0100)
Subject: Re: bug#64101: 29.0.91; Eglot inlay hints rendered out of order
References: <AF24CBF4-1342-4D92-B7F9-8EE717BD8250@HIDDEN>
 <83r0qar07l.fsf@HIDDEN> <877cs28m23.fsf@HIDDEN>
 <83edmaqskn.fsf@HIDDEN> <87352q8ent.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 64101
Cc: kklimonda@HIDDEN, 64101 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: João Távora <joaotavora@HIDDEN>
> Cc: kklimonda@HIDDEN,  64101 <at> debbugs.gnu.org,
>  monnier@HIDDEN
> Date: Sat, 17 Jun 2023 13:19:18 +0100
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > Emacs 29 comes with a completely different implementation of overlays
> > than previous versions.
> >
> > I don't think this is specific to macOS, but perhaps the order in
> > which overlays are arranged is arbitrary to some extent, in which case
> > different systems can have different orders.
> 
> I would find this "undefined order" strange, and perhaps a bug in
> itself.  Maybe whoever rewrote the overlay code (Stefan?) could chime
> in.

It wasn't Stefan, he just merged the branch to master and fixed bugs.

But why do you say this is a bug?  Does any documentation promise any
particular order of overlays?

> In any case, one defensive option is to push the patch I showed to Emacs
> 29.  Subject, of course, to testing on at least some machine where the
> problem does indeed happen.

Yes, let's wait for the confirmation that it fixes the problem.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#64101; Package emacs. Full text available.

Message received at 64101 <at> debbugs.gnu.org:


Received: (at 64101) by debbugs.gnu.org; 17 Jun 2023 12:27:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 17 08:27:19 2023
Received: from localhost ([127.0.0.1]:51005 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qAV1S-0001IQ-MK
	for submit <at> debbugs.gnu.org; Sat, 17 Jun 2023 08:27:19 -0400
Received: from out3-smtp.messagingengine.com ([66.111.4.27]:56483)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <kklimonda@HIDDEN>) id 1qAV1Q-0001IA-5z
 for 64101 <at> debbugs.gnu.org; Sat, 17 Jun 2023 08:27:17 -0400
Received: from compute1.internal (compute1.nyi.internal [10.202.2.41])
 by mailout.nyi.internal (Postfix) with ESMTP id 23C385C0186;
 Sat, 17 Jun 2023 08:27:11 -0400 (EDT)
Received: from imap44 ([10.202.2.94])
 by compute1.internal (MEProxy); Sat, 17 Jun 2023 08:27:11 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 syntaxhighlighted.com; h=cc:cc:content-transfer-encoding
 :content-type:content-type:date:date:from:from:in-reply-to
 :in-reply-to:message-id:mime-version:references:reply-to:sender
 :subject:subject:to:to; s=fm1; t=1687004831; x=1687091231; bh=jK
 sHJVRQQBgtbzJShyLrMta5laXyvHpPw7lL9CVNIAw=; b=Qks/EUKtk9Ck87b2gS
 L67wi+egSMGMS0hLpMIEi80RESMD7BdqlmcokHyqpJq6ylIE8HMAai50pjP/htfb
 eAXyREn14uljugqEu+1DgsF/bVKhfCmpOjnb8DUKMx2SCyjVTfozCM/gx2/0ALik
 eKyV4gol1Rq/hRHdhbzg60KfTCBaeSi+BYdjHc4tWXpiWE0v/MYaTmQb7e4qIHlG
 R9Pnjn1wra/2yrxorZfNJF1L2Lo6CW/KhSNE0A/wwK/tPD4clEVXph7Qe8uqVCzn
 Ezj4BlaOtCeMkTdY1H77sWpMyt2MAI9h8TuhxPc8YJuMagzxJD3qmbSrtaKtxon8
 rsYQ==
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 messagingengine.com; h=cc:cc:content-transfer-encoding
 :content-type:content-type:date:date:feedback-id:feedback-id
 :from:from:in-reply-to:in-reply-to:message-id:mime-version
 :references:reply-to:sender:subject:subject:to:to:x-me-proxy
 :x-me-proxy:x-me-sender:x-me-sender:x-sasl-enc; s=fm2; t=
 1687004831; x=1687091231; bh=jKsHJVRQQBgtbzJShyLrMta5laXyvHpPw7l
 L9CVNIAw=; b=h5/jCr/NOONrna0oG2FVJiMF5JPSW0QoLWn9an1fHROiOI0rNMO
 gM6Sh5MG02hNRd+TvJ9B7IScCotq8LmrlhxJx6hQxPV7wa5tcAO5f4AQ8kdVLVdn
 pQ9pu+07OrgJ++7nmfTvXV4re3M8TzpYks5k9C423nHKxkKKvkCQhLhDwIqcBnVi
 PR4KjhsxUWOZqg3tnY8ZRykdJF7nKVlsQEvEY6ypttQf1S0au7xBH9FHruSnWhZw
 gwkVOEuLZbgjoug2aKMzWRCT9CMmKhVFcyKTEsAVeQbA/6bzOYLtYD0JiFBdkekl
 JQel2UNfxQPrhNY7mMQACrCxZnTVsvP4xzA==
X-ME-Sender: <xms:nqaNZC-mfo3oFkLtqAtP74Tei7HaaprCu5VplOmX6OKF7K_e4oXf-Q>
 <xme:nqaNZCsYhUUseORZmrrhUAA4Y3ImfcOxPcdc5npSHuiig71v6zsZyB1mH7uv3cYUY
 4v13QHBCgTid0jUVQ>
X-ME-Proxy-Cause: gggruggvucftvghtrhhoucdtuddrgedvhedrgedvjedgheduucetufdoteggodetrfdotf
 fvucfrrhhofhhilhgvmecuhfgrshhtofgrihhlpdfqfgfvpdfurfetoffkrfgpnffqhgen
 uceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmne
 cujfgurhepofgfggfkjghffffhvfevufgtgfesthhqredtreerjeenucfhrhhomhepfdfm
 rhiihihsiihtohhfucfmlhhimhhonhgurgdfuceokhhklhhimhhonhgurgesshihnhhtrg
 ighhhighhhlhhighhhthgvugdrtghomheqnecuggftrfgrthhtvghrnhepvdeiteeiuedv
 uedthedtgfdvffehheejvdeuvdfhtdeguedvtdffffegleethfffnecuffhomhgrihhnpe
 hgihhthhhusgdrtghomhenucevlhhushhtvghrufhiiigvpedtnecurfgrrhgrmhepmhgr
 ihhlfhhrohhmpehkkhhlihhmohhnuggrsehshihnthgrgihhihhghhhlihhghhhtvggurd
 gtohhm
X-ME-Proxy: <xmx:nqaNZIBEZrbLVWp1JMU5m7Rt2t7APdnk3tZyGM0WhiadObyCCvVwdg>
 <xmx:nqaNZKeW-fVU1rKZog5fcE687kt7HN4Dkr1U9Oxw6kfptYpzpRMmxQ>
 <xmx:nqaNZHPz1uhSBFr3yfv972YTGbbVcagL6Sy6kZ3tt56hX8T2omo2kQ>
 <xmx:n6aNZJVxh5Zlj4dso5Ie_yewcvBIXYmtN6pZIwjbo_bPY6aV9MV52g>
Feedback-ID: i3888429f:Fastmail
Received: by mailuser.nyi.internal (Postfix, from userid 501)
 id AD91336A0075; Sat, 17 Jun 2023 08:27:10 -0400 (EDT)
X-Mailer: MessagingEngine.com Webmail Interface
User-Agent: Cyrus-JMAP/3.9.0-alpha0-496-g8c46984af0-fm-20230615.001-g8c46984a
Mime-Version: 1.0
Message-Id: <cad9acf5-e871-4edb-a52c-cca26b5675c9@HIDDEN>
In-Reply-To: <877cs28m23.fsf@HIDDEN>
References: <AF24CBF4-1342-4D92-B7F9-8EE717BD8250@HIDDEN>
 <83r0qar07l.fsf@HIDDEN> <877cs28m23.fsf@HIDDEN>
Date: Sat, 17 Jun 2023 14:26:49 +0200
From: "Krzysztof Klimonda" <kklimonda@HIDDEN>
To: =?UTF-8?Q?Jo=C3=A3o_T=C3=A1vora?= <joaotavora@HIDDEN>,
 "Eli Zaretskii" <eliz@HIDDEN>
Subject: Re: bug#64101: 29.0.91; Eglot inlay hints rendered out of order
Content-Type: text/plain;charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 64101
Cc: 64101 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Hi Joao,

The attached patch has indeed fixed the issue.

Additionally, I've tested the behaviour on emacs 28.2 and the bug persis=
ts, so it seems to be unrelated to any overlay changes.

On Sat, Jun 17, 2023, at 11:39, Jo=C3=A3o T=C3=A1vora wrote:
> Eli Zaretskii <eliz@HIDDEN> writes:
>
>> Jo=C3=A3o, are you looking into this? =20
>
> I looked at a very similar issue:=20
> https://github.com/joaotavora/eglot/discussions/1239
>
> There, Milan Jovanovic , reports something very similar,
> if not completely identical, for Emacs 29.  I asked
> Milan to send mail here.  Maybe Krzystof and Milan are
> related, or this is just a coincidence?
>
> Anyway, I tried to reproduce the problem on both Emacs 29
> and 30 and couldn't.
>
> The problem also doesn't happen on Emacs 28.  So I don't know what is =
up
> and the "recent overlay rewrite" (when?) doesn't seem to have an effec=
t.
> I don't have a Mac OS machine to test.
>
>> Should the overlays created for the
>> inlay hints be forced to be sorted in some particular order?
>
> Maybe, and there is definitely an order they should be sorted.
> But as far as I can personally observe, there is no problem yet,
> so it would be best to first understand the problem.
>
> But maybe Milan/Krzystof can try this patch:
>
> diff --git a/lisp/progmodes/eglot.el b/lisp/progmodes/eglot.el
> index a65795f1dfc..0c000f72ec7 100644
> --- a/lisp/progmodes/eglot.el
> +++ b/lisp/progmodes/eglot.el
> @@ -3755,8 +3755,9 @@ eglot--update-hints-1
>                       (if peg-after-p
>                           (make-overlay (point) (1+ (point)) nil t)
>                         (make-overlay (1- (point)) (point) nil nil=20
> nil)))
> -                   (do-it (label lpad rpad firstp)
> -                     (let* ((tweak-cursor-p (and firstp peg-after-p))
> +                   (do-it (label lpad rpad i)
> +                     (let* ((firstp (zerop i))
> +                            (tweak-cursor-p (and firstp peg-after-p))
>                              (ov (make-ov))
>                              (text (concat lpad label rpad)))
>                         (when tweak-cursor-p (put-text-property 0 1=20
> 'cursor 1 text))
> @@ -3767,17 +3768,18 @@ eglot--update-hints-1
>                                               (1 'eglot-type-hint-face)
>                                               (2=20
> 'eglot-parameter-hint-face)
>                                               (_=20
> 'eglot-inlay-hint-face))))
> +                       (overlay-put ov 'priority i)
>                         (overlay-put ov 'eglot--inlay-hint t)
>                         (overlay-put ov 'evaporate t)
>                         (overlay-put ov 'eglot--overlay t))))
> -                (if (stringp label) (do-it label left-pad right-pad t)
> +                (if (stringp label) (do-it label left-pad right-pad 0)
>                    (cl-loop
>                     for i from 0 for ldetail across label
>                     do (eglot--dbind ((InlayHintLabelPart) value)=20
> ldetail
>                          (do-it value
>                                 (and (zerop i) left-pad)
>                                 (and (=3D i (1- (length label)))=20
> right-pad)
> -                               (zerop i))))))))))
> +                               i)))))))))
>      (jsonrpc-async-request
>       (eglot--current-server-or-lose)
>       :textDocument/inlayHint

--=20
  Krzysztof Klimonda
  kklimonda@HIDDEN




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#64101; Package emacs. Full text available.

Message received at 64101 <at> debbugs.gnu.org:


Received: (at 64101) by debbugs.gnu.org; 17 Jun 2023 12:17:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 17 08:17:02 2023
Received: from localhost ([127.0.0.1]:50988 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qAUrV-0000zT-IC
	for submit <at> debbugs.gnu.org; Sat, 17 Jun 2023 08:17:02 -0400
Received: from mail-wm1-f54.google.com ([209.85.128.54]:53554)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <joaotavora@HIDDEN>) id 1qAUrS-0000zB-1p
 for 64101 <at> debbugs.gnu.org; Sat, 17 Jun 2023 08:17:00 -0400
Received: by mail-wm1-f54.google.com with SMTP id
 5b1f17b1804b1-3f8fd8b603aso10803875e9.3
 for <64101 <at> debbugs.gnu.org>; Sat, 17 Jun 2023 05:16:58 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=gmail.com; s=20221208; t=1687004212; x=1689596212;
 h=content-transfer-encoding:mime-version:user-agent:message-id:date
 :references:in-reply-to:subject:cc:to:from:from:to:cc:subject:date
 :message-id:reply-to;
 bh=cRHNRkzsfAc6Nxmt7dFL3woDm+kWdxPkT2FL5GuhaMM=;
 b=Aae+wDny/MtlfoAXnTNxJF+Vf4qr0eBz91N7zj0J5lxap3tAnNV9NDkdmnFEcDsdeF
 HdR9fVM4YZ7D1Id+o3CQwmkgxq0HUJ30x81q4F+9moDUHe7UID830laP/poEiW1Dusx0
 D8Xbp3/iyobxffXDd/3mR8YRhyRnz5tiYMaFnZBSLVmqTST7auyC0xWOtorvv9UhJmAB
 yMdVDDhwFiC3Z8OQF8v5nYtTxLywTBPwm8xpMib5GFgTqmxFEjuq+t3Hc8BeS+RQn+0H
 h/mXneX3dJPsrAZy7lWHtHDVcY2TBgbg/Dt4PgTn/Fb5w9p1bD46n7xbnP6+sY2bkatI
 ViiQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20221208; t=1687004212; x=1689596212;
 h=content-transfer-encoding:mime-version:user-agent:message-id:date
 :references:in-reply-to:subject:cc:to:from:x-gm-message-state:from
 :to:cc:subject:date:message-id:reply-to;
 bh=cRHNRkzsfAc6Nxmt7dFL3woDm+kWdxPkT2FL5GuhaMM=;
 b=FISGviUWMUQtdFuA52pHY8Q4EM2Y+A+z4K4UwaKmTb7VOhN6n/A126FxiHsWNmzBjX
 sc/5EHhRzT7jQXod/+O3zXKuOjo0lHAvLIcEtCl4du6YPQiL/MOTOYX4BlqDMvY0Zd+i
 7J2USL9BuLr8F823jCsKAOI3SHKT+8PbVgachqIrL4N3IXxcob/FAE/t7QQazs9+wonb
 7q9/v1rIoWv1R0yfSLR6HgWV/LGcxoL6GBNU2BYPmWFjNjqL7Vqq+yeMXiceNsuO6ZRQ
 nPKB2JiVDoPHktvg0BCQ5bLJJ6iHf32cks6iXDJi/41McpW/gpId4SAWnkk4B7FfRqsZ
 efVw==
X-Gm-Message-State: AC+VfDyfu9VP2HdpUYAh8I6xXYTbuSoKc0VUqACDS7DGI6ds1qMAODKK
 M9TdcqpEpRwMIv9e29oRGKE=
X-Google-Smtp-Source: ACHHUZ5jbkm+brMh7BN6IjrpPWXJ/6XXJNhi1eMH6PjRaTjERDrZtmC6YXxPMUs0eSLZManlZAVGTg==
X-Received: by 2002:a05:600c:28d2:b0:3f7:e809:f41d with SMTP id
 h18-20020a05600c28d200b003f7e809f41dmr4233161wmd.4.1687004211746; 
 Sat, 17 Jun 2023 05:16:51 -0700 (PDT)
Received: from krug ([87.196.73.15]) by smtp.gmail.com with ESMTPSA id
 f13-20020a7bcd0d000000b003f7ba52eeccsm4874015wmj.7.2023.06.17.05.16.50
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 17 Jun 2023 05:16:51 -0700 (PDT)
From: =?utf-8?B?Sm/Do28gVMOhdm9yYQ==?= <joaotavora@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#64101: 29.0.91; Eglot inlay hints rendered out of order
In-Reply-To: <83edmaqskn.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 17 Jun
 2023 13:41:28 +0300")
References: <AF24CBF4-1342-4D92-B7F9-8EE717BD8250@HIDDEN>
 <83r0qar07l.fsf@HIDDEN> <877cs28m23.fsf@HIDDEN>
 <83edmaqskn.fsf@HIDDEN>
Date: Sat, 17 Jun 2023 13:19:18 +0100
Message-ID: <87352q8ent.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 64101
Cc: kklimonda@HIDDEN, 64101 <at> debbugs.gnu.org,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Jo=C3=A3o T=C3=A1vora <joaotavora@HIDDEN>
>> Cc: Krzysztof Klimonda <kklimonda@HIDDEN>,
>>   64101 <at> debbugs.gnu.org
>> Date: Sat, 17 Jun 2023 10:39:32 +0100
>>=20
>> Anyway, I tried to reproduce the problem on both Emacs 29
>> and 30 and couldn't.
>>=20
>> The problem also doesn't happen on Emacs 28.  So I don't know what is up
>> and the "recent overlay rewrite" (when?) doesn't seem to have an effect.
>> I don't have a Mac OS machine to test.
>
> Emacs 29 comes with a completely different implementation of overlays
> than previous versions.
>
> I don't think this is specific to macOS, but perhaps the order in
> which overlays are arranged is arbitrary to some extent, in which case
> different systems can have different orders.

I would find this "undefined order" strange, and perhaps a bug in
itself.  Maybe whoever rewrote the overlay code (Stefan?) could chime
in.

In any case, one defensive option is to push the patch I showed to Emacs
29.  Subject, of course, to testing on at least some machine where the
problem does indeed happen.

Jo=C3=A3o




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#64101; Package emacs. Full text available.

Message received at 64101 <at> debbugs.gnu.org:


Received: (at 64101) by debbugs.gnu.org; 17 Jun 2023 10:41:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 17 06:41:48 2023
Received: from localhost ([127.0.0.1]:50917 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qATNL-0004Dt-Uz
	for submit <at> debbugs.gnu.org; Sat, 17 Jun 2023 06:41:48 -0400
Received: from eggs.gnu.org ([209.51.188.92]:35758)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1qATNJ-0004Dh-Jy
 for 64101 <at> debbugs.gnu.org; Sat, 17 Jun 2023 06:41:46 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1qATN7-0006fW-I2; Sat, 17 Jun 2023 06:41:40 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-version:References:Subject:In-Reply-To:To:From:
 Date; bh=1l0/W63K1dJYm+sDikAomSzoo9wlO0X9E1GHYJEEQ78=; b=B/yTfd/Qh9Pztkni1aM7
 QiBIdQZhL63Mqf2OYTZ5lUWGJ+H0bsO2IWGifw05eqYDdgeqccD0MhvZZq+IN9BUeI5XB3A/etUaE
 S40BdDRPdn8b/azGEwsYd//HRWwr35kLLwDsmuIbz1XyAznr40lEGYvgXt0RVi204yjM0ByDJHU/9
 FWVYZADarFK2tuxW/S6Yvs9q8BczB/1OPuAxopJsq/hu3L9eXFkaIGU0BM1+ylfpX4PSdZqvHivVx
 A+On/WcO0TgpWKNXwuvLxMJfTVxY2duhw9g9OHQ9Q1PSDHSET9kHBB0pwRt10xtF+glkbnWrH5Dx0
 4j54yojc6FuICw==;
Received: from [87.69.77.57] (helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1qATN3-0008VD-Jc; Sat, 17 Jun 2023 06:41:33 -0400
Date: Sat, 17 Jun 2023 13:41:28 +0300
Message-Id: <83edmaqskn.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: =?utf-8?B?Sm/Do28gVMOhdm9yYQ==?= <joaotavora@HIDDEN>
In-Reply-To: <877cs28m23.fsf@HIDDEN> (message from =?utf-8?B?Sm/Do28g?=
 =?utf-8?B?VMOhdm9yYQ==?= on Sat, 17 Jun 2023 10:39:32 +0100)
Subject: Re: bug#64101: 29.0.91; Eglot inlay hints rendered out of order
References: <AF24CBF4-1342-4D92-B7F9-8EE717BD8250@HIDDEN>
 <83r0qar07l.fsf@HIDDEN> <877cs28m23.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 64101
Cc: kklimonda@HIDDEN, 64101 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: João Távora <joaotavora@HIDDEN>
> Cc: Krzysztof Klimonda <kklimonda@HIDDEN>,
>   64101 <at> debbugs.gnu.org
> Date: Sat, 17 Jun 2023 10:39:32 +0100
> 
> Anyway, I tried to reproduce the problem on both Emacs 29
> and 30 and couldn't.
> 
> The problem also doesn't happen on Emacs 28.  So I don't know what is up
> and the "recent overlay rewrite" (when?) doesn't seem to have an effect.
> I don't have a Mac OS machine to test.

Emacs 29 comes with a completely different implementation of overlays
than previous versions.

I don't think this is specific to macOS, but perhaps the order in
which overlays are arranged is arbitrary to some extent, in which case
different systems can have different orders.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#64101; Package emacs. Full text available.

Message received at 64101 <at> debbugs.gnu.org:


Received: (at 64101) by debbugs.gnu.org; 17 Jun 2023 09:37:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 17 05:37:14 2023
Received: from localhost ([127.0.0.1]:50889 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qASMs-0002Kn-CZ
	for submit <at> debbugs.gnu.org; Sat, 17 Jun 2023 05:37:14 -0400
Received: from mail-wm1-f47.google.com ([209.85.128.47]:57419)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <joaotavora@HIDDEN>) id 1qASMq-0002Ka-2p
 for 64101 <at> debbugs.gnu.org; Sat, 17 Jun 2023 05:37:13 -0400
Received: by mail-wm1-f47.google.com with SMTP id
 5b1f17b1804b1-3f8fcaa3155so10132725e9.2
 for <64101 <at> debbugs.gnu.org>; Sat, 17 Jun 2023 02:37:12 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=gmail.com; s=20221208; t=1686994626; x=1689586626;
 h=content-transfer-encoding:mime-version:user-agent:message-id:date
 :references:in-reply-to:subject:cc:to:from:from:to:cc:subject:date
 :message-id:reply-to;
 bh=RJSgJy3S9vv/RvtDXppB2uC/p/BJwbEnqf9BVilsRu0=;
 b=ELJDSE3cRYs9+ET+jV1XSwnaXaxhZluQpmfbHbwe2+GwKNQGHAAvgbSO4h1cFNPVtL
 iI8y2FnpZtyo6luhohBk48M8vhr6iz2Fr5MXU1e9SMrDF6LH25f60qKuo5KTnmqJBGyL
 P7DbiqCZRwRrTfWs8vwD53f06kdDC22WJXEp9TVdh8AprYlj+IatQHDfaxry8xsGrvHG
 41B4E91eykkk8oqRDpLZVvProFUi/clkptxsJdV9qmcjrvg/2kh4vEzctprUgVN950KK
 cRxnnJgSDuwRhnG04t79igymidIkDM+gUHQv6zd1+6y+GXIuYOuVGITZRxb9D3QT/4Pb
 KKNg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20221208; t=1686994626; x=1689586626;
 h=content-transfer-encoding:mime-version:user-agent:message-id:date
 :references:in-reply-to:subject:cc:to:from:x-gm-message-state:from
 :to:cc:subject:date:message-id:reply-to;
 bh=RJSgJy3S9vv/RvtDXppB2uC/p/BJwbEnqf9BVilsRu0=;
 b=hoSyIquCBTe7RfgkSpNopOR4QHmBJaVpjYg1I1eQZ+ZbpsAGZqg/brVe1Gty+73F0m
 OyQgUXJ1krbtgOtQxiL8cabGQ7/Sl7BD28To/fZXfy6i87Ap8p8FN7dICl4wfGvNPQkr
 /uFJT0y8J6srw2719IHvbBYJBV2iOjschsvtF9cTxTtbtWSGIutOCZh5GfkrVMLTNdYb
 IDtWOsHcVDEFToVzJVv/NRU3xAL29ePRyAT0XMfbjwO3TkLMpRmHlx1YX2T/lK3/8DOg
 09Pixoa5uaAKe33YduaHN2gikwlF33PbMAORVxnAfbQi9eBYSbMIS9YJQosfAfDjm6z1
 XZ1g==
X-Gm-Message-State: AC+VfDz6JRhYfWAMnyYE9eZhSu0LEQ1bAfBx5ZOZjN/uKYhxSKDLFxrT
 N4fj+vudawzkzkUk3iA6O7fjdk4uPPk=
X-Google-Smtp-Source: ACHHUZ4gVGRWc0kWJpW36eygb+qObDZ9B6xU0j2skIDOrTBjb44Es5sanFQ8xDTOa52vVrCwYxli1Q==
X-Received: by 2002:a05:600c:2241:b0:3f9:7fa:62fb with SMTP id
 a1-20020a05600c224100b003f907fa62fbmr622301wmm.25.1686994625635; 
 Sat, 17 Jun 2023 02:37:05 -0700 (PDT)
Received: from krug ([87.196.73.15]) by smtp.gmail.com with ESMTPSA id
 o1-20020a05600c378100b003f50d6ee334sm4443068wmr.47.2023.06.17.02.37.04
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 17 Jun 2023 02:37:05 -0700 (PDT)
From: =?utf-8?B?Sm/Do28gVMOhdm9yYQ==?= <joaotavora@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#64101: 29.0.91; Eglot inlay hints rendered out of order
In-Reply-To: <83r0qar07l.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 17 Jun
 2023 10:56:30 +0300")
References: <AF24CBF4-1342-4D92-B7F9-8EE717BD8250@HIDDEN>
 <83r0qar07l.fsf@HIDDEN>
Date: Sat, 17 Jun 2023 10:39:32 +0100
Message-ID: <877cs28m23.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 64101
Cc: Krzysztof Klimonda <kklimonda@HIDDEN>, 64101 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> Jo=C3=A3o, are you looking into this?=20=20

I looked at a very similar issue: https://github.com/joaotavora/eglot/discu=
ssions/1239

There, Milan Jovanovic , reports something very similar,
if not completely identical, for Emacs 29.  I asked
Milan to send mail here.  Maybe Krzystof and Milan are
related, or this is just a coincidence?

Anyway, I tried to reproduce the problem on both Emacs 29
and 30 and couldn't.

The problem also doesn't happen on Emacs 28.  So I don't know what is up
and the "recent overlay rewrite" (when?) doesn't seem to have an effect.
I don't have a Mac OS machine to test.

> Should the overlays created for the
> inlay hints be forced to be sorted in some particular order?

Maybe, and there is definitely an order they should be sorted.
But as far as I can personally observe, there is no problem yet,
so it would be best to first understand the problem.

But maybe Milan/Krzystof can try this patch:

diff --git a/lisp/progmodes/eglot.el b/lisp/progmodes/eglot.el
index a65795f1dfc..0c000f72ec7 100644
--- a/lisp/progmodes/eglot.el
+++ b/lisp/progmodes/eglot.el
@@ -3755,8 +3755,9 @@ eglot--update-hints-1
                      (if peg-after-p
                          (make-overlay (point) (1+ (point)) nil t)
                        (make-overlay (1- (point)) (point) nil nil nil)))
-                   (do-it (label lpad rpad firstp)
-                     (let* ((tweak-cursor-p (and firstp peg-after-p))
+                   (do-it (label lpad rpad i)
+                     (let* ((firstp (zerop i))
+                            (tweak-cursor-p (and firstp peg-after-p))
                             (ov (make-ov))
                             (text (concat lpad label rpad)))
                        (when tweak-cursor-p (put-text-property 0 1 'cursor=
 1 text))
@@ -3767,17 +3768,18 @@ eglot--update-hints-1
                                              (1 'eglot-type-hint-face)
                                              (2 'eglot-parameter-hint-face)
                                              (_ 'eglot-inlay-hint-face))))
+                       (overlay-put ov 'priority i)
                        (overlay-put ov 'eglot--inlay-hint t)
                        (overlay-put ov 'evaporate t)
                        (overlay-put ov 'eglot--overlay t))))
-                (if (stringp label) (do-it label left-pad right-pad t)
+                (if (stringp label) (do-it label left-pad right-pad 0)
                   (cl-loop
                    for i from 0 for ldetail across label
                    do (eglot--dbind ((InlayHintLabelPart) value) ldetail
                         (do-it value
                                (and (zerop i) left-pad)
                                (and (=3D i (1- (length label))) right-pad)
-                               (zerop i))))))))))
+                               i)))))))))
     (jsonrpc-async-request
      (eglot--current-server-or-lose)
      :textDocument/inlayHint




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#64101; Package emacs. Full text available.

Message received at 64101 <at> debbugs.gnu.org:


Received: (at 64101) by debbugs.gnu.org; 17 Jun 2023 07:56:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 17 03:56:40 2023
Received: from localhost ([127.0.0.1]:50807 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qAQnY-00088H-2Q
	for submit <at> debbugs.gnu.org; Sat, 17 Jun 2023 03:56:40 -0400
Received: from eggs.gnu.org ([209.51.188.92]:48092)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1qAQnW-00087y-21
 for 64101 <at> debbugs.gnu.org; Sat, 17 Jun 2023 03:56:38 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1qAQnQ-0003J4-QL; Sat, 17 Jun 2023 03:56:32 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-version:References:Subject:In-Reply-To:To:From:
 Date; bh=KQ6rse8R+NISxZa7ppFNyj0I9Uu8Z0MlLENDZFBCDGk=; b=N5fLjUG/dsSEJG3fPztp
 cJQkSxfWVLMhjNPwnFBGqXBSj3phIplJhw+Ae9Zb9KCEqN4Q+IRk5ayMXIlIUN8I2gu5aikjNK8Se
 D95vY5gh0XBWnQP0pi0rxyyGTn6MX/VMBDnZep+d59ScDT+wqqfkMocOCjMixVFt2G6rC6Mj6Xs8z
 XRmsCMxhONur40NhsliPZCMXOXfN/DL7ExcFte5R1CPsT5xXBjCjT9znkeYPHdgclgGhzj6qpUhLv
 8MCcZlgGIb6ddbcAP1wRKTWCwnFtkK44x9dnVGRSAV+yMvXQwq6/c2pJ+q/Hhucc1bmSyJr8gg7LX
 iqhw+7jcH+Z4PA==;
Received: from [87.69.77.57] (helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1qAQnP-0006v3-0V; Sat, 17 Jun 2023 03:56:32 -0400
Date: Sat, 17 Jun 2023 10:56:30 +0300
Message-Id: <83r0qar07l.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Krzysztof Klimonda <kklimonda@HIDDEN>,
 =?iso-8859-1?Q?Jo=E3o_T=E1vora?= <joaotavora@HIDDEN>
In-Reply-To: <AF24CBF4-1342-4D92-B7F9-8EE717BD8250@HIDDEN>
 (message from Krzysztof Klimonda on Thu, 15 Jun 2023 23:23:45 +0200)
Subject: Re: bug#64101: 29.0.91; Eglot inlay hints rendered out of order
References: <AF24CBF4-1342-4D92-B7F9-8EE717BD8250@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 64101
Cc: 64101 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Krzysztof Klimonda <kklimonda@HIDDEN>
> Date: Thu, 15 Jun 2023 23:23:45 +0200
> 
> 
> When using eglot with rust-analyzer some inlay hints are not rendered
> correctly. For example, in the following code snippet, inlay hint for
> the `let vec =` is rendered as such:
> 
> > >>>Vec<Arc<Mutex<Item: 
> 
> and not
> 
> > : <Vec<Arc<Mutex<Item>>>
> 
> It works fine for simple hints (like `let x` in my example).
> 
> Looking at what's happening, it seems eglot is creating separate
> overlays for each element of the returned `InlayHintLabelPart` with
> the same beginning in the buffer. From poking around I've noticed
> that overlays have been rewritten recently, and the order of overlays
> for the given position no longer seems to be fixed.
> 
> Code example below:
> ---8<---8<---8<---
> use std::sync::{Arc, Mutex};
> 
> mod static_uninit;
> 
> struct Item;
> 
> fn test() {
>     let vec = vec![Arc::new(Mutex::new(Item))];
>     let x = 1;
> }
> ---8<---8<---8<---

Joo, are you looking into this?  Should the overlays created for the
inlay hints be forced to be sorted in some particular order?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#64101; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 16 Jun 2023 05:56:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jun 16 01:56:52 2023
Received: from localhost ([127.0.0.1]:48477 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1qA2S3-0006nD-GN
	for submit <at> debbugs.gnu.org; Fri, 16 Jun 2023 01:56:52 -0400
Received: from lists.gnu.org ([209.51.188.17]:60024)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <kklimonda@HIDDEN>) id 1q9uRo-0008Cg-OU
 for submit <at> debbugs.gnu.org; Thu, 15 Jun 2023 17:24:05 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10])
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <kklimonda@HIDDEN>)
 id 1q9uRo-0004kK-El
 for bug-gnu-emacs@HIDDEN; Thu, 15 Jun 2023 17:24:04 -0400
Received: from out2-smtp.messagingengine.com ([66.111.4.26])
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <kklimonda@HIDDEN>)
 id 1q9uRm-0000WW-55
 for bug-gnu-emacs@HIDDEN; Thu, 15 Jun 2023 17:24:04 -0400
Received: from compute4.internal (compute4.nyi.internal [10.202.2.44])
 by mailout.nyi.internal (Postfix) with ESMTP id E4CF55C00FB
 for <bug-gnu-emacs@HIDDEN>; Thu, 15 Jun 2023 17:23:59 -0400 (EDT)
Received: from mailfrontend2 ([10.202.2.163])
 by compute4.internal (MEProxy); Thu, 15 Jun 2023 17:23:59 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 syntaxhighlighted.com; h=cc:content-transfer-encoding
 :content-type:content-type:date:date:from:from:in-reply-to
 :message-id:mime-version:reply-to:sender:subject:subject:to:to;
 s=fm1; t=1686864239; x=1686950639; bh=Iur6SmZ6ghf5+GO9vDdJ4mBvu
 qJ3uAZG+/2tldsos18=; b=geeeF27ZRIcXDERrLxDxeT9vY9uvQDa9acAc+ofRX
 uxKWSKlYTpPxYXhvL+WgnsDxiHo/WK0rHvH4+851GBPlhsVrFdh4+ngfHt1i1XBN
 pFQk95jVVp+2wZv53htTKaGA7iwpWbD2gIJ5k4lbTuT3ds9D6HKYqpzwAbIRXNP+
 GXOLdRpfs2LeSelJPW+rY91Novbj7wwjjwmKWJIgT0RDlPIlzmtqcy5NIOlxebf5
 ZnLxdNaQ2NAkc5gLRWFumxp5MWUdY5VoNiIESFMp2h1NMu9wiIIge0VEqO2h9EQg
 3EfFqncWuhTRGW3QqyahLgGCBEITIyfKyNdJeV8ug047Q==
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 messagingengine.com; h=cc:content-transfer-encoding:content-type
 :content-type:date:date:feedback-id:feedback-id:from:from
 :in-reply-to:message-id:mime-version:reply-to:sender:subject
 :subject:to:to:x-me-proxy:x-me-proxy:x-me-sender:x-me-sender
 :x-sasl-enc; s=fm2; t=1686864239; x=1686950639; bh=Iur6SmZ6ghf5+
 GO9vDdJ4mBvuqJ3uAZG+/2tldsos18=; b=jQLWbr2T9sr7OwG5yujIw5jW4fo7E
 clJXdRnCcSQNKgKeYQwwakTsgekjgE/jzmgSVy6eobHVH/AvkDnAjnREhoL9e+Bg
 vSLI84W8U7dN03sUEYUrYGgTGnYgdmo6MnndFLD0Wi+4I5vtizD0FNnOLPR96NBx
 ZVzg8J+Dn4sehVwo3RBEmZyKa2TPcG1AH0sgSDMpyp0XNAAs3XccIEuOBLZ6lgXH
 DA67+bNDFfM+hY9WcIx/XlCoBDPQHTX3gufPIj2/xVaxtvsv74/9+E8NUmi81ktY
 9+46YVxP0BpLA3RZ+wANyOQWfLLgaQkchGz7MxgdLbMNWZi7RUibgJC9g==
X-ME-Sender: <xms:b4GLZJwESJeMonfGKxabeJB0SVe9qu3DhuSD7atL_Jgcq7kxNTY4Gg>
 <xme:b4GLZJQ6lO2Q8enwVMlb-S5S7bY-tb9DbUhHX5CbBi4dABEid7m4jtGn1im8q-mSd
 ZPPFPOuhJZnHsEVcw>
X-ME-Received: <xmr:b4GLZDVBjqQic_OtYQ4mzYyj4XkKtlfSkRDPrtU1froxDqnkG_9WUDqLe2WuTjNVhSvFIJwtb5OGmG-KFXd7Sd0K6r9r2Pw>
X-ME-Proxy-Cause: gggruggvucftvghtrhhoucdtuddrgedvhedrgedvvddgudehjecutefuodetggdotefrod
 ftvfcurfhrohhfihhlvgemucfhrghsthforghilhdpqfgfvfdpuffrtefokffrpgfnqfgh
 necuuegrihhlohhuthemuceftddtnecunecujfgurhephfgtgfgguffkfffvofesthejmh
 dthhdtvdenucfhrhhomhepmfhriiihshiithhofhcumfhlihhmohhnuggruceokhhklhhi
 mhhonhgurgesshihnhhtrgighhhighhhlhhighhhthgvugdrtghomheqnecuggftrfgrth
 htvghrnhepjeeufeffgedtkedtteffffeijeeguefffeehhedtheeuudfhiefhjefhieek
 uefgnecuvehluhhsthgvrhfuihiivgeptdenucfrrghrrghmpehmrghilhhfrhhomhepkh
 hklhhimhhonhgurgesshihnhhtrgighhhighhhlhhighhhthgvugdrtghomh
X-ME-Proxy: <xmx:b4GLZLjN5jYetsFOSHM6oTtpjizxAgBpVP20YI8t2n17XZMwZJ0IZQ>
 <xmx:b4GLZLCr_C6Z9MLebGuN29x6wtJ82o-djBlIPAfbFZ9vxWk3bliuzw>
 <xmx:b4GLZELW-2qrq1Y1RYGdRUhyhw6xnZWKeUwB1-zJ9EHERiQSUvzXjQ>
 <xmx:b4GLZO-rpYOdeE88c2sH_5KMFQk_LQ29RAQyP0vnvUsWphouS7DuwQ>
Feedback-ID: i3888429f:Fastmail
Received: by mail.messagingengine.com (Postfix) with ESMTPA for
 <bug-gnu-emacs@HIDDEN>; Thu, 15 Jun 2023 17:23:59 -0400 (EDT)
From: Krzysztof Klimonda <kklimonda@HIDDEN>
Content-Type: text/plain;
	charset=us-ascii
Content-Transfer-Encoding: 7bit
Mime-Version: 1.0 (Mac OS X Mail 16.0 \(3731.400.51.1.1\))
Subject: 29.0.91; Eglot inlay hints rendered out of order
Message-Id: <AF24CBF4-1342-4D92-B7F9-8EE717BD8250@HIDDEN>
Date: Thu, 15 Jun 2023 23:23:45 +0200
To: bug-gnu-emacs@HIDDEN
X-Mailer: Apple Mail (2.3731.400.51.1.1)
Received-SPF: pass client-ip=66.111.4.26;
 envelope-from=kklimonda@HIDDEN;
 helo=out2-smtp.messagingengine.com
X-Spam_score_int: -27
X-Spam_score: -2.8
X-Spam_bar: --
X-Spam_report: (-2.8 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1,
 RCVD_IN_DNSWL_LOW=-0.7, RCVD_IN_MSPIKE_H3=0.001, RCVD_IN_MSPIKE_WL=0.001,
 SPF_HELO_PASS=-0.001, SPF_PASS=-0.001,
 T_SCC_BODY_TEXT_LINE=-0.01 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.6 (-)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Fri, 16 Jun 2023 01:56:47 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.6 (--)


When using eglot with rust-analyzer some inlay hints are not rendered
correctly. For example, in the following code snippet, inlay hint for
the `let vec =` is rendered as such:

> >>>Vec<Arc<Mutex<Item: 

and not

> : <Vec<Arc<Mutex<Item>>>

It works fine for simple hints (like `let x` in my example).

Looking at what's happening, it seems eglot is creating separate
overlays for each element of the returned `InlayHintLabelPart` with
the same beginning in the buffer. From poking around I've noticed
that overlays have been rewritten recently, and the order of overlays
for the given position no longer seems to be fixed.

Code example below:
---8<---8<---8<---
use std::sync::{Arc, Mutex};

mod static_uninit;

struct Item;

fn test() {
    let vec = vec![Arc::new(Mutex::new(Item))];
    let x = 1;
}
---8<---8<---8<---




In GNU Emacs 29.0.91 (build 1, x86_64-apple-darwin22.3.0, NS
appkit-2299.40 Version 13.2.1 (Build 22D68)) of 2023-06-11 built on
sapphire.local
Windowing system distributor 'Apple', version 10.3.2299
System Description:  macOS 13.2.1

Configured using:
'configure --disable-dependency-tracking --disable-silent-rules
--enable-locallisppath=/usr/local/share/emacs/site-lisp
--infodir=/usr/local/Cellar/emacs-plus@29/29.0.90/share/info/emacs
--prefix=/usr/local/Cellar/emacs-plus@29/29.0.90 --with-xml2
--with-gnutls --with-native-compilation --without-compress-install
--without-dbus --without-imagemagick --with-modules --with-rsvg
--with-ns --disable-ns-self-contained 'CFLAGS=-Os -w -pipe
-march=nehalem -mmacosx-version-min=13
-isysroot/Library/Developer/CommandLineTools/SDKs/MacOSX13.sdk
-DFD_SETSIZE=10000 -DDARWIN_UNLIMITED_SELECT'
'CPPFLAGS=-I/usr/local/opt/zlib/include -I/usr/local/opt/jpeg/include
-I/usr/local/opt/icu4c/include -I/usr/local/opt/openssl@HIDDEN/include
-F/usr/local/Frameworks
-isysroot/Library/Developer/CommandLineTools/SDKs/MacOSX13.sdk'
'LDFLAGS=-L/usr/local/opt/zlib/lib -L/usr/local/opt/jpeg/lib
-L/usr/local/opt/icu4c/lib -L/usr/local/opt/openssl@HIDDEN/lib
-L/usr/local/lib -F/usr/local/Frameworks
-Wl,-headerpad_max_install_names
-isysroot/Library/Developer/CommandLineTools/SDKs/MacOSX13.sdk
-L/usr/local/opt/libgccjit/lib''

Configured features:
ACL GIF GLIB GMP GNUTLS JPEG JSON LCMS2 LIBXML2 MODULES NATIVE_COMP
NOTIFY KQUEUE NS PDUMPER PNG RSVG SQLITE3 THREADS TIFF
TOOLKIT_SCROLL_BARS TREE_SITTER WEBP XIM ZLIB

Important settings:
  value of $LC_CTYPE: UTF-8
  value of $LANG: en_US.UTF-8
  locale-coding-system: utf-8-unix

Major mode: Rust

Minor modes in effect:
  shell-dirtrack-mode: t
  eglot-inlay-hints-mode: t
  eglot--managed-mode: t
  flymake-mode: t
  tooltip-mode: t
  global-eldoc-mode: t
  eldoc-mode: t
  show-paren-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  line-number-mode: t
  indent-tabs-mode: t
  transient-mark-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t

Load-path shadows:
None found.

Features:
(shadow sort mail-extr emacsbug message mailcap yank-media puny dired
dired-loaddefs rfc822 mml mml-sec epa derived epg rfc6068 epg-config
gnus-util mm-decode mm-bodies mm-encode mail-parse rfc2231 mailabbrev
gmm-utils mailheader sendmail rfc2047 rfc2045 ietf-drums mm-util
mail-prsvr mail-utils misearch multi-isearch pulse color rust-ts-mode
c-ts-common treesit etags fileloop generator time-date shell pcomplete
eglot external-completion array filenotify jsonrpc ert pp ewoc debug
backtrace find-func xref flymake-proc flymake thingatpt compile
text-property-search comint ansi-osc ansi-color ring pcase url-util
url-parse auth-source eieio eieio-core password-cache json map url-vars
project byte-opt imenu vc-git diff-mode easy-mmode vc-dispatcher
cl-loaddefs comp comp-cstr warnings icons subr-x rx cl-seq cl-macs gv
cl-extra help-mode bytecomp byte-compile cl-lib rmc iso-transl tooltip
cconv eldoc paren electric uniquify ediff-hook vc-hooks lisp-float-type
elisp-mode mwheel term/ns-win ns-win ucs-normalize mule-util
term/common-win tool-bar dnd fontset image regexp-opt fringe
tabulated-list replace newcomment text-mode lisp-mode prog-mode register
page tab-bar menu-bar rfn-eshadow isearch easymenu timer select
scroll-bar mouse jit-lock font-lock syntax font-core term/tty-colors
frame minibuffer nadvice seq simple cl-generic indonesian philippine
cham georgian utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao
korean japanese eucjp-ms cp51932 hebrew greek romanian slovak czech
european ethiopic indian cyrillic chinese composite emoji-zwj charscript
charprop case-table epa-hook jka-cmpr-hook help abbrev obarray oclosure
cl-preloaded button loaddefs theme-loaddefs faces cus-face macroexp
files window text-properties overlay sha1 md5 base64 format env
code-pages mule custom widget keymap hashtable-print-readable backquote
threads kqueue cocoa ns lcms2 multi-tty make-network-process
native-compile emacs)

Memory information:
((conses 16 161413 14006)
(symbols 48 12244 0)
(strings 32 41810 3481)
(string-bytes 1 1383853)
(vectors 16 31896)
(vector-slots 8 582797 14839)
(floats 8 140 71)
(intervals 56 375 0)
(buffers 984 22))




Acknowledgement sent to Krzysztof Klimonda <kklimonda@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#64101; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Sat, 17 Jun 2023 21:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.